unit untAllSubscribedTopics;

interface

uses
  Classes,
  untOfflineBoard, untTopic;

type
  TAllSubscribedTopics = class(TOfflineBoard)
  private
    FThread: TThread;
  public
    procedure AppendTopic(Topic: TTopic); override;
    procedure RemoveTopic(Topic: TTopic); override;
    constructor Create;
    procedure Stop;
    procedure SendTopicList; override;
    procedure Save; override;
    procedure FreeAllTopic; override;
  end;

implementation

uses
  untTool, untAllSubscribedTopicsLoadThread, untBoard, untOnlineBoard;

procedure TAllSubscribedTopics.FreeAllTopic;
var
  i: integer;
  tp: TTopic;
begin

  for i := 0 to TopicList.Count - 1 do
  begin
    tp := TopicList[i];
    TOnlineBoard(tp.OnlineBoard).FreeTopic(tp);
  end;
  TopicList.Clear;
end;

constructor TAllSubscribedTopics.Create;
begin
  inherited Create(AppPath('g܂'));
end;

procedure TAllSubscribedTopics.SendTopicList;
begin
  TopicList.Clear;

  State := stDownloading;
  FThread := TAllSubscribedTopicsLoadThread.Create(true);
  with TAllSubscribedTopicsLoadThread(FThread) do
  begin
    FreeOnTerminate := false;
    Board := self;
    Resume;
    WaitFor;
    Free;
  end;
  FThread := nil;
  if Assigned(OnReceived) then
  begin
    OnReceived(self);
  end;
  State := stIdling;
end;

procedure TAllSubscribedTopics.Stop;
begin
  if Assigned(FThread) then
  begin
    FThread.Terminate;
  end;
end;

procedure TAllSubscribedTopics.AppendTopic(Topic: TTopic);
begin
  TopicList.Add(Topic);
end;

procedure TAllSubscribedTopics.RemoveTopic(Topic: TTopic);
begin
  TopicList.Remove(Topic);
end;

procedure TAllSubscribedTopics.Save;
begin
  // S擾̓t@CɕۑȂ
end;

end.
 