unit untBoard2ch;

interface

uses
  untOnlineBoard, IdComponent, untTopic;

type
  TBoard2ch = class(TOnlineBoard)
  private
    LastModified: string;
  protected
    procedure HttpReceived(Sender: TObject); override;
    procedure HttpComplete(Sender: TObject); override;
  public
    procedure SendTopicList; override;
    procedure DownloadTopic(Topic: TTopic; sender: TObject); override;
    function HasTopicListChange: boolean;
  end;

implementation

uses
  untTopic2ch, untGlobal, untTopic2chKako, untBoard,
  untHttp, untConfig, untTopic2chDolib;

function TBoard2ch.HasTopicListChange: boolean;
begin
  if LastModified = '' then
  begin
    result := true;
    exit;
  end;
  State := stArrivalChecking;
  FHttp := TAsyncHttp.Create;
  FHttp.UserAgent := gConfig.UserAgent;
  FHttp.AddHeader('X-2ch-UA', APP_2chUA);
  gConfig.InitReadProxy(FHttp);
  FHttp.URL := 'http://' + Server + '/' + BoardName + '/subject.txt';
  FHttp.OnStatus := HttpStatusChange;
  FHttp.Head;
  result := false;
  if FHttp.LastModified <> LastModified then
  begin
    result := true;
  end;
  FHttp.Free;
  State := stIdling;
end;

procedure TBoard2ch.DownloadTopic(Topic: TTopic; sender: TObject);
var
  ti: string;

begin
  inherited;

  // ʐMJn
  if (Topic.ResponseCode = 416) or
     (Topic.ErrorCode = etAbone) or
     (Topic.ErrorCode = etParse) or
     (Topic.ErrorCode = etBrokenGZip) then
  begin
    // W[sȂŏŃgC
    // ځ[񂩉̓G[gzipĂȂ烊gC
    Topic.Retry;
  end else if TTopic2ch(Topic).IsFreezed then
  begin
    // DAT
    ti := Topic.TopicId;
    FreeTopic(Topic);
    GC;
    Topic := TTopic2chKako.Create(self, ti);
    TopicList.Add(Topic);
    inherited DownloadTopic(Topic, sender);
    if (gConfig.SessionId <> '') and not TTopic2chKako(Topic).IsExist then
    begin
      ti := Topic.TopicId;
      FreeTopic(Topic);
      GC;
      Topic := TTopic2chDolib.Create(self, ti);
      TopicList.Add(Topic);
      inherited DownloadTopic(Topic, sender);
    end;
  end;
end;

procedure TBoard2ch.SendTopicList;
begin
  inherited;

  FHttp.UseGzip := true;

  FHttp.OnReceived := HttpReceived;
  FHttp.OnComplete := HttpComplete;

  FHttp.URL := 'http://' + Server + '/' + BoardName + '/subject.txt';
  FHttp.Resume;
end;

procedure TBoard2ch.HttpComplete(Sender: TObject);
begin
  LastModified := FHttp.LastModified;
  inherited;
end;

procedure TBoard2ch.HttpReceived(Sender: TObject);
begin
  inherited HttpReceivedProc('^(.+?)\.dat<>(.*) \((.+?)\)$');
end;

end.
