unit untMyFolder;

interface

uses
  untBoardCategory, untAllSubscribedTopics,
  untOfflineBoard, untLostTopics, untBoard;

type
  TMyFolder = class(TBoardCategory)
  protected
  public
    AllSubscribedTopics: TAllSubscribedTopics;
    FavoriteBoard: TOfflineBoard;
    LostTopics: TLostTopics;
    function AddBoard(const FavidxPath, Category, DisplayName: string): TBoard;
  end;

implementation

function TMyFolder.AddBoard(const FavidxPath, Category, DisplayName: string): TBoard;
var
  b: TBoard;

begin
  if DisplayName = 'qX' then
  begin
    b := TLostTopics.Create;
    LostTopics := TLostTopics(b);
  end else if DisplayName = 'SX' then
  begin
    b := TAllSubscribedTopics.Create;
    AllSubscribedTopics := TAllSubscribedTopics(b);
  end else
  begin
    b := TOfflineBoard.Create(FavidxPath);
  end;
  b.Category    := self;
  b.BoardList   := BoardList;
  b.DisplayName := DisplayName;
  Boards.Add(b);
  result := b;
end;

end.
 